;include \MASM32\INCLUDE\masm32rt.inc
include \masm32\MasmBasic\MasmBasic.inc 

WinMain proto :DWORD,:DWORD,:DWORD,:DWORD

IDBITMAP		equ	123   ; BITMAP

.data
   	ClassName 	db "MainWinClass",0
   	AppName  	db "Main Window",0
  
   	classbutton	db	"Button",0
   	anyname		db	"name",0
	classStatic	db	"Static",0

	hstatic		dd	0
	hbutton		dd	0

	hBITMAP		dd	0
.data?
   hInstance HINSTANCE ?
   CommandLine LPSTR ?

.code
start:
	invoke GetModuleHandle, NULL
	mov    hInstance,eax	
	invoke GetCommandLine
	mov    CommandLine,eax
	invoke WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT
	invoke ExitProcess,eax

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
	LOCAL hwnd:HWND
	
	mov   wc.cbSize,SIZEOF WNDCLASSEX
	mov   wc.style, CS_HREDRAW or CS_VREDRAW
	mov   wc.lpfnWndProc, OFFSET WndProc
	mov   wc.cbClsExtra,NULL
	mov   wc.cbWndExtra,NULL
	push  hInstance
	pop   wc.hInstance
	mov   wc.hbrBackground,COLOR_BTNFACE+1
	mov   wc.lpszMenuName,NULL
	mov   wc.lpszClassName,OFFSET ClassName
	
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov   wc.hIcon,eax
	mov   wc.hIconSm,eax
	
	invoke LoadCursor,NULL,IDC_ARROW
	mov   wc.hCursor,eax
	
	invoke RegisterClassEx, addr wc
	INVOKE CreateWindowEx,NULL,ADDR ClassName,ADDR AppName,\
           WS_OVERLAPPEDWINDOW,360,
           100,100h,100h,NULL,NULL,\
           hInst,NULL
	mov   hwnd,eax
	
	invoke ShowWindow, hwnd,SW_SHOWNORMAL
	invoke UpdateWindow, hwnd
	
	.WHILE TRUE
		invoke GetMessage, ADDR msg,NULL,0,0
		.BREAK .IF (!eax)
		invoke TranslateMessage, ADDR msg
		invoke DispatchMessage, ADDR msg
	.ENDW
	
	mov     eax,msg.wParam
	ret
WinMain endp

WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
		LOCAL   PS:PAINTSTRUCT
        LOCAL   hdc1:HDC
        LOCAL   hdc2:HDC
        LOCAL   hdc3:HDC
        LOCAL   hBmpOrg2:DWORD
        LOCAL   hBmpOrg3:DWORD
	
	.IF uMsg==WM_DESTROY
		invoke PostQuitMessage,NULL
	.ELSEIF uMsg==WM_CREATE
	invoke	CreateWindowEx,NULL,addr classbutton,addr anyname,WS_VISIBLE or WS_CHILD or WS_VISIBLE, \
	0,0,50h,30h,hWnd,NULL,hInstance,NULL
	mov		hbutton,eax
	
	invoke CreateWindowEx,NULL,addr classStatic,addr anyname,5000000Eh, \
	70h,0,50,30,hWnd,NULL,hInstance,NULL
	mov		hstatic,eax		

	invoke	LoadBitmap,hInstance,IDBITMAP
	mov		hBITMAP,eax
	.if eax
		deb 4, "WM_Create OK", hBITMAP
	.else
		deb 4, "WM_Create ERROR", $Err$()
	.endif

	.ELSEIF uMsg==WM_COMMAND
		invoke	GetDC,hstatic
		mov		hdc1,eax
		invoke	CreateCompatibleDC,hdc1
		mov		hdc2,eax
			deb 4, "A", hdc1, hdc2,hBITMAP
		;	invoke	CreateCompatibleDC,hdc1
		;	mov		hdc3,eax

		invoke	SelectObject,hdc2,hBITMAP
		mov		hBmpOrg2,eax
		deb 4, "SelObj", hBmpOrg2
		;	invoke  CreateCompatibleBitmap,hdc1,64,64
		;        invoke  SelectObject,hdc3,eax
		;	mov     hBmpOrg3,eax                           ;save the original handle from hdc3
		;	invoke  BitBlt,hdc3,0,0,64,64,hdc2,0,0,SRCCOPY ;i try copy to temporary....
		invoke  BitBlt,hdc1,0,0,64,64,hdc2,0,0,SRCCOPY ;now, copy to static control
		deb 4, "BitBlt", eax
		;        invoke  SelectObject,hdc3,hBmpOrg3
		;        invoke  DeleteObject,eax
		invoke  SelectObject,hdc2,hBmpOrg2
		deb 4, "SelObj", eax
		invoke  DeleteObject, hBmpOrg2	;eax ; eax is wrong
		deb 4, "DelObj", eax
		;       	invoke  DeleteDC,hdc3
		invoke  DeleteDC,hdc2
		deb 4, "DelDC", eax
		invoke  ReleaseDC,hstatic,hdc1
		deb 4, "RelDC", eax
		; invoke ValidateRect, hWnd, 0
		xor eax, eax
		; result , the picture all black color
		ret
	.ELSE
		;invoke CallWindowProc,WndProc,hWnd,uMsg,wParam,lParam
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam		
		ret
	.ENDIF
	
	xor eax,eax
	ret
WndProc endp
end start
OPT_Res	rsrc
OPT_Assembler	ml
OPT_Tmp2Asm	1
